import {config,is,pageLogin,getUrl,sandBox,cookieStorage} from '../../../es6/myapp.js';
Page({
    data: {
        list:[],
        Height:'',
        total_pages:2,
        current_page:1,
        reduce_items_id:'',
        limit:10

    },
    onLoad: function() {
        var windowHeight = wx.getSystemInfoSync().windowHeight//获取设备的高度
        this.setData({
            Height:windowHeight
        })
        this.getList();
    },
    getList(){
        var token = cookieStorage.get('user_token'); 
        let that =this
        sandBox.get({
            api:`api/reduce/list/me?limit=${that.data.limit} `,
            header: {
				Authorization: token
            },
            data:{
                page:this.data.current_page
            }
        }).then(res=>{
            if(res.statusCode == 200){
                res=res.data
                if(res.status){
                    that.setData({
                        current_page:res.meta.pagination.current_page,
                        [`list[${res.meta.pagination.current_page-1}]`]:res.data,
                        length:res.data.length,
                        total_pages:res.meta.pagination.total_pages,
                    })
                }else{
                    wx.showToast({
                        title:'获取砍价列表失败',
                        icon: 'none',
                        duration:2000
                    })
                }
            }
        })
    },
    toDetail(e){
        this.setData({
            reduce_items_id:e.currentTarget.dataset.reduceId
        })
        wx.navigateTo({
            url: `/pages/bargain/details/details?reduce_items_id=${this.data.reduce_items_id}`
        })
    },
    onPullDownRefresh: function() {
        
    },
    onReachBottom(){
        if(this.data.current_page<this.data.total_pages){
            this.data.current_page++
            this.getList()
        }else{
            wx.showToast({
                title: '再拉也没有了',
                icon: 'none',
                duration:2000
            })
        }
    }
})