import { config, sandBox, cookieStorage } from "../../../es6/myapp.js";
Page({
  data: {
    type: "personal",
    order_no: "",
    content: "",
    name: "",
    address: "",
    phone: "",
    bank_number: "",
    bank: "",
    number: ""
  },
  onLoad(e) {
    this.setData({
      order_no: e.order_no
    });
  },
  onShow() {
  },
  change(e) {
    this.setData({
      type: e.detail.value
    });
  },
  name(e) {
    this.setData({
      name: e.detail.value
    });
  },
  number(e) {
    this.setData({
      number: e.detail.value
    });
  },
  bank(e) {
    this.setData({
      bank: e.detail.value
    });
  },
  bank_number(e) {
    this.setData({
      bank_number: e.detail.value
    });
  },
  phone(e) {
    this.setData({
      phone: e.detail.value
    });
  },
  address(e) {
    this.setData({
      address: e.detail.value
    });
  },
  submit() {
    var type = "";
    if (this.data.type == "personal") {
      if (this.data.name == "") {
        return wx.showToast({
          title: "请输入姓名",
          image: "../../../assets/image/error.png"
        });
      }
    } else {
      if (this.data.name == "") {
        return wx.showToast({
          title: "请输入单位名称",
          image: "../../../assets/image/error.png"
        });
      }
      if (this.data.number == "") {
        return wx.showToast({
          title: "请输入税号 ",
          image: "../../../assets/image/error.png"
        });
      }
    }
    let invoice = {
      type: this.data.type,
      name: this.data.name,
      number: this.data.number,
      bank: this.data.bank,
      bank_number: this.data.bank_number,
      phone: this.data.phone,
      address: this.data.address
    };
    // cookieStorage.set('invoice', invoice);
    this.addInvoiceInfo(invoice);
  },
  back(){
    wx.navigateBack();
  },
  // 添加发票信息
  addInvoiceInfo(invoice) {
    var pages = getCurrentPages(); //获取页面栈
    var prevPage = pages[pages.length - 2]; //上一页面
    prevPage.setData({
        invoice:invoice //给上一个页面赋值
    });
    wx.navigateBack();

  }
});
