import {config,sandBox,modelLogin, getUrl} from '../../../es6/myapp.js';

Page({
  data: {
    detail: {}
  },
  jump(e){
    var url=e.currentTarget.dataset.url;
    wx.navigateTo({
        url: url
    })
  },
  jumpPut() {

  },
  onLoad() {
    this.getIncome()
  },
  getIncome() {
    modelLogin(getUrl(), (token) => {
      wx.showLoading()
      sandBox.get({
        api: 'api/course/user/income',
        header: {
          authorization: token
        }
      }).then(res => {
        wx.hideLoading()
        res = res.data
        if(res.status) {
          this.setData({
            detail: res.data
          })
        } else {
          wx.showToast({
            title: typeof res.message === 'string' ? res.message : '获取收益明细失败',
            icon: 'none'
          })
        }
      }).catch(e => {
        wx.hideLoading()
        wx.showToast({
          title: '获取收益明细失败',
          icon: 'none'
        })
      })
    })
  },
  showHelp() {
    wx.showModal({
      title: '平台合伙人规则',
      content: '邀请好友,注册并开通会员卡,你将获得会员卡面额30%的提成.',
      showCancel: false
    })
  }
})